﻿namespace UltraGridUpdateCellValue
{
    using System.Data;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public const int ColsCount = 2;
        public const int RowsCount = 2;

        private DataTable dt = new DataTable();

        public Form1()
        {
            this.InitializeComponent();
            this.BuildGrid(ColsCount);
            this.LoadData(RowsCount);
            this.ultraGrid.DisplayLayout.Override.CellClickAction = CellClickAction.CellSelect;
        }

        private void BuildGrid(int colsCount)
        {
            for (int col = 0; col < colsCount; col++)
            {
                this.dt.Columns.Add(string.Format("Name {0}", col), typeof(CellClass));
            }
        }

        private void LoadData(int rowsCount)
        {
            for (int row = 0; row < rowsCount; row++)
            {
                this.dt.Rows.Add(new CellClass(new MyClass(row.ToString())), new CellClass(new MyClass((row + ColsCount).ToString())));
            }

            this.ultraGrid.DataSource = this.dt;

            foreach (UltraGridColumn col in this.ultraGrid.DisplayLayout.Bands[0].Columns)
            {
                col.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Edit;
                var editor = col.Editor;

                if (editor.DataFilter == null)
                {
                    editor.DataFilter = new MyDataFilter();
                }
            }
        }

        private void UltraGrid1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete || e.KeyCode == Keys.Back)
            {
                if (0 == (this.ultraGrid.CurrentState & UltraGridState.InEdit))
                {
                    if (this.ultraGrid.ActiveCell != null)
                    {
                        var cellVal = this.ultraGrid.ActiveCell.Value as CellClass;

                        if (cellVal == null)
                        {
                            return;
                        }

                        cellVal.Clear();
                        this.ultraGrid.ActiveCell.Row.Refresh();
                    }
                }
            }
        }
    }
}
