﻿namespace UltraGridUpdateCellValue
{
    using Infragistics.Win;

    public class MyDataFilter : IEditorDataFilter
    {
        public object Convert(EditorDataFilterConvertArgs conversionArgs)
        {
            switch (conversionArgs.Direction)
            {
                case ConversionDirection.DisplayToEditor:
                case ConversionDirection.EditorToDisplay:
                    {
                        string value = conversionArgs.Value as string;
                        if (null != value)
                        {
                            conversionArgs.Handled = true;
                            conversionArgs.IsValid = true;
                            return value;
                        }

                        break;
                    }

                case ConversionDirection.EditorToOwner:
                    {
                        string value = conversionArgs.Value as string;
                        if (null != value)
                        {
                            conversionArgs.IsValid = true;
                            conversionArgs.Handled = true;
                            return new CellClass(new MyClass(value));
                        }

                        break;
                    }

                case ConversionDirection.OwnerToEditor:
                    {
                        CellClass value = conversionArgs.Value as CellClass;
                        conversionArgs.Handled = true;
                        conversionArgs.IsValid = true;
                        if (null != value && null != value.RealValue)
                        {
                            return value.RealValue.MyProperty;
                        }
                        else
                        {
                            return string.Empty;
                        }
                    }
            }

            return conversionArgs.Value;
        }
    }
}
